<?php
namespace OrganizationsManagement\Controller;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource;
use OrganizationsManagement\Service;

class Operador extends Simple {
    private $serviceOperador;

    public function __construct(Service\Operador $serviceOperador){
        $this->serviceOperador = $serviceOperador;
    }

    public function gerarSenha(DTO\Request\DataSet $requisicao, DTO\Response $resposta){
        try {
            $detalhes = $requisicao->getDataSet()->getRows()[0];
            $idOrganizacao = empty($detalhes['NRORG']) ? null : $detalhes['NRORG'];
            $emailOperador = empty($detalhes['DSEMAILOPER']) ? null : $detalhes['DSEMAILOPER'];
            $this->serviceOperador->redefineSenha($idOrganizacao, $emailOperador);
            $resposta->addMessage(new DTO\Response\Message("Senha gerada com sucesso e enviada para o e-mail do operador."));
        } catch(\Exception $ex){
            $resposta->setError(new Error($ex->getMessage(), $ex->getCode()));
        }
    }
} 