-- ================================================================== --
-- SISTEMA         : PEDIDO                                           --
-- DATA DA CRIAO : INCIO - 31/08/2004                              --
-- CRIAO         : Andr Rodrigo                                    --
-- OBJETIVO        : Grava os produtos na ITDESPREBASE                --
-- @C:\WIN_V4\SQL\END_CONV\ORACLE\2855_PEDSTPO.SQL                    --
-- ================================================================== --
CREATE OR REPLACE PROCEDURE GRAVA_ITDESPREBASE(
   P_CDPRECOBASE  IN ITDESPREBASE.CDPRECOBASE%TYPE,
   P_CDPAIS       IN ITDESPREBASE.CDPAIS%TYPE,
   P_LISTAESTADO  IN VARCHAR2,
   P_VRPEMAXDESPR IN ITDESPREBASE.VRPEMAXDESPR%TYPE,
   P_CDPRODINI    IN PRODUTO.CDARVPROD%TYPE,
   P_CDPRODFIN    IN PRODUTO.CDARVPROD%TYPE,
   P_IDTRATADESC  IN PEDIDO.IDSITPEDIDO%TYPE
) IS

   V_CTPROD NUMBER;
BEGIN
   FOR C_EST IN
      (SELECT SGESTADO
       FROM ESTADO
       WHERE (CDPAIS = P_CDPAIS)
         AND ((INSTR(P_LISTAESTADO, SGESTADO) <> 0)OR( P_LISTAESTADO = 'T'))
       ORDER BY SGESTADO) LOOP

      FOR C_PROD IN
         (SELECT CDPRODUTO
          FROM PRODUTO
          WHERE CDARVPROD BETWEEN P_CDPRODINI AND P_CDPRODFIN
            AND CDPRODESTO IS NOT NULL
          ORDER BY CDARVPROD) LOOP

         SELECT COUNT(CDPRODUTO) INTO V_CTPROD
         FROM ITDESPREBASE
         WHERE CDPRECOBASE = P_CDPRECOBASE
           AND CDPAIS      = P_CDPAIS
           AND SGESTADO    = C_EST.SGESTADO
           AND CDPRODUTO   = C_PROD.CDPRODUTO;

         IF (V_CTPROD > 0) THEN
            IF (P_IDTRATADESC = 'S') THEN
               UPDATE ITDESPREBASE
               SET VRPEMAXDESPR = P_VRPEMAXDESPR
               WHERE CDPRECOBASE = P_CDPRECOBASE
                 AND CDPAIS      = P_CDPAIS
                 AND SGESTADO    = C_EST.SGESTADO
                 AND CDPRODUTO   = C_PROD.CDPRODUTO;
            END IF;
         ELSE
            INSERT INTO ITDESPREBASE
               (CDPRECOBASE, CDPAIS, SGESTADO, CDPRODUTO, VRPEMAXDESPR)
            VALUES
               (P_CDPRECOBASE, P_CDPAIS, C_EST.SGESTADO, C_PROD.CDPRODUTO, P_VRPEMAXDESPR);
         END IF;
      END LOOP;
   END LOOP;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('GRAVA_ITDESPREBASE','4.09.034'); END;
/

